import { SealedInitialState } from "reakit-utils/useSealedState";
import { SetState } from "reakit-utils/types";
import { unstable_GridState as GridState, unstable_GridActions as GridActions, unstable_GridInitialState as GridInitialState } from "../Grid/GridState";
import { ComboboxBaseState, ComboboxBaseActions, ComboboxBaseInitialState } from "./__utils/ComboboxBaseState";
export declare function unstable_useComboboxMenuGridState(initialState?: SealedInitialState<unstable_ComboboxMenuGridInitialState>): unstable_ComboboxMenuGridStateReturn;
export declare type unstable_ComboboxMenuGridState = Omit<ComboboxBaseState<GridState>, "matches"> & {
    /**
     * Number of columns by which `values` will be splitted to generate the
     * `matches` 2D array.
     */
    columns: number;
    /**
     * Result of filtering `values` based on `inputValue`.
     * @default []
     * @example
     * const combobox = useComboboxState({
     *   values: ["Red", "Green", "Blue"],
     *   columns: 2,
     * });
     * combobox.matches; // [["Red", "Green"], ["Blue"]]
     * combobox.setInputValue("g");
     * // On next render
     * combobox.matches; // [["Green"]]
     */
    matches: string[][];
};
export declare type unstable_ComboboxMenuGridActions = ComboboxBaseActions<GridActions> & {
    /**
     * Sets `columns`.
     */
    setColumns: SetState<unstable_ComboboxMenuGridState["columns"]>;
};
export declare type unstable_ComboboxMenuGridInitialState = Omit<GridInitialState, "unstable_virtual" | "unstable_includesBaseElement"> & ComboboxBaseInitialState & Pick<Partial<unstable_ComboboxMenuGridState>, "columns">;
export declare type unstable_ComboboxMenuGridStateReturn = unstable_ComboboxMenuGridState & unstable_ComboboxMenuGridActions;
